using System;
using System.Collections.Generic;
using Library;
using LitJson;
using System.Linq;
using System.Data;
using System.Threading;
using MySystem.PxcModels;

namespace MySystem
{
    public class LeaderPrizeService
    {
        public readonly static LeaderPrizeService Instance = new LeaderPrizeService();
        private LeaderPrizeService()
        { }

        public void Start()
        {
            Thread th = new Thread(dosomething);
            th.IsBackground = true;
            th.Start();
        }

        public void dosomething()
        {
            while (true)
            {
                string data = RedisDbconn.Instance.RPop<string>("LeaderPrizeQueue");
                if (!string.IsNullOrEmpty(data))
                {
                    try
                    {
                        int PosId = int.Parse(function.CheckInt(data));
                        WebCMSEntities db = new WebCMSEntities();
                        PosMachinesTwo pos = db.PosMachinesTwo.FirstOrDefault(m => m.Id == PosId && m.LeaderUserId > 0);
                        if (pos != null)
                        {
                            bool IsGet = true;
                            if(Utils.Instance.IsWifi(pos.BrandId))
                            {
                                int Count = db.UserAccountRecord.Count(m => m.QueryCount == PosId && m.ChangeType == 116);
                                int Count1 = db.WifiTradeRecord.Count(m => m.SnNo == pos.PosSn);
                                IsGet = Count >= Count1;
                            }
                            else
                            {
                                IsGet = db.UserAccountRecord.Any(m => m.QueryCount == PosId && m.ChangeType == 116);
                            }
                            if(!IsGet)
                            {
                                decimal ChangeAmount = 10;
                                if(pos.BrandId == 14)
                                {
                                    ChangeAmount = 19 * 0.15M;
                                }
                                if(Utils.Instance.IsWifi(pos.BrandId))
                                {
                                    int tradeCount = db.WifiTradeRecord.Count(m => m.SnNo == pos.PosSn);
                                    if (tradeCount > 0)
                                    {
                                        ChangeAmount = db.WifiTradeRecord.Where(m => m.SnNo == pos.PosSn).OrderByDescending(m => m.Id).FirstOrDefault().TradeAmount * 0.015M;
                                        ChangeAmount = PublicFunction.NumberFormat(ChangeAmount);
                                    }
                                    else
                                    {
                                        ChangeAmount = 0;
                                    }
                                }
                                if(ChangeAmount > 0)
                                {
                                    int LeaderUserId = pos.LeaderUserId;
                                    UserAccount account = db.UserAccount.FirstOrDefault(m => m.Id == LeaderUserId);
                                    if (account == null)
                                    {
                                        account = db.UserAccount.Add(new UserAccount()
                                        {
                                            Id = LeaderUserId,
                                            UserId = LeaderUserId,
                                        }).Entity;
                                        db.SaveChanges();
                                    }
                                    decimal BeforeTotalAmount = account.TotalAmount; //变更前总金额
                                    decimal BeforeFreezeAmount = account.FreezeAmount; //变更前冻结金额
                                    decimal BeforeBalanceAmount = account.BalanceAmount; //变更前余额
                                    account.BalanceAmount += ChangeAmount;
                                    account.TotalAmount += ChangeAmount;
                                    decimal AfterTotalAmount = account.TotalAmount; //变更后总金额
                                    decimal AfterFreezeAmount = account.FreezeAmount; //变更后冻结金额
                                    decimal AfterBalanceAmount = account.BalanceAmount; //变更后余额
                                    UserAccountRecord userAccountRecord = db.UserAccountRecord.Add(new UserAccountRecord()
                                    {
                                        CreateDate = DateTime.Now,
                                        UpdateDate = DateTime.Now,
                                        UserId = LeaderUserId, //创客
                                        ProductType = pos.BrandId, //品牌
                                        ChangeType = 116, //变动类型
                                        ChangeAmount = ChangeAmount, //变更金额
                                        BeforeTotalAmount = BeforeTotalAmount, //变更前总金额
                                        AfterTotalAmount = AfterTotalAmount, //变更后总金额
                                        BeforeFreezeAmount = BeforeFreezeAmount, //变更前冻结金额
                                        AfterFreezeAmount = AfterFreezeAmount, //变更后冻结金额
                                        BeforeBalanceAmount = BeforeBalanceAmount, //变更前余额
                                        AfterBalanceAmount = AfterBalanceAmount, //变更后余额
                                        QueryCount = PosId,
                                        Kind = 3,
                                    }).Entity;
                                    db.SaveChanges();
                                }
                            }
                        }
                        db.Dispose();
                    }
                    catch (Exception ex)
                    {
                        Utils.WriteLog(DateTime.Now.ToString() + "\r\n" + ex.ToString(), "大盟主奖励异常");
                    }
                    Thread.Sleep(100);
                }
                else
                {
                    Thread.Sleep(60000);
                }
            }
        }
    }
}